<template>
  <div class="ChangeEmail">
    <h2>{{ t(`page.settings.email.title`) }}</h2>

    <form class="ChangeEmailForm" @submit.prevent="submitEmailChange">
      <span class="p-float-label">
        <p-InputText
          id="email"
          v-model="email"
          :class="errors['email'] ? 'p-invalid' : ''"
          type="email"
        />
        <label for="email">{{ t('resource.user.email') }}</label>
      </span>
      <ErrorWrapper :errors="errors['email']" />
      <p-Button
        :label="t('page.settings.email.submit')"
        type="submit"
        class="p-button-outlined ChangeEmail__submit"
        :disabled="disabled"
      />
    </form>
  </div>
</template>
<script lang="ts" setup>
import { useI18n } from 'vue-i18n'
import { computed, onMounted, ref } from 'vue'
import { addMessage, settings } from '@/states'
import { useFormValidation } from '@/components/form'
import { userClient } from '@/api'
import { AxiosError } from 'axios'

const { t } = useI18n()
const { errors, clearErrors, parseViolations } = useFormValidation()
const email = ref<string>('')
const disabled = computed(
  () => email.value && email.value === settings.user.email
)

/**
 * Submit user email change
 */
async function submitEmailChange() {
  try {
    clearErrors()

    await userClient.patch(settings.user.id, { email: email.value })

    addMessage({
      severity: 'success',
      summary: t('toast.success.change_email.saved.summary'),
      detail: t('toast.success.change_email.saved.detail'),
      life: 3000,
    })
  } catch (e) {
    if ((e as AxiosError)?.response?.status === 422) {
      parseViolations((e as AxiosError)?.response?.data.violations)
      return
    }

    addMessage({
      severity: 'error',
      summary: t('toast.error.title'),
      detail: t('toast.error.change_email.saved.detail'),
      life: 6000,
    })
  }
}

onMounted(async () => {
  email.value = settings.user.email as string
})
</script>
<style lang="scss" scoped>
@use 'src/style/variables' as v;

.ChangeEmailForm {
  padding-top: v.$spacing;
}
</style>
